select
    an.numero as numero
    , an.nome as nome
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as raca
    , se.nome as "SETOR ATUAL"
    , cob.data as "LTIMA INSEMINAO"
    , (select count(*) from reproducao re where re.cdtiporeproducao in (1,2,3) and re.cdanimal = an.cdanimal and re.data < coalesce(par.data, '1900-01-01') and re.data > coalesce(parant.data, '1900-01-01')) as "N TENTATIVAS AT A ULT CONCEPO"
    , (case cob.cdtiporeproducao when 1 then 'Inseminacao' when 2 then 'Cobertura' when 3 then 'Transferncia de embrio'
        else null end) as "TIPO FECUNDAO" 
    , (select count(*) from reproducao re where re.cdtiporeproducao = 7 and re.cdanimal = an.cdanimal) as "ORDEM PARTO"
    , par.data as "LTIMO PARTO"
    , tp.descricao as "TIPO PARTO"
    , (par.data - cob.data) as "DURAO GESTAO"    
from            
    animal an
    left join reproducao par on par.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdtiporeproducao = 7 and re.cdanimal = an.cdanimal order by re.data desc)
    left join reproducao parant on parant.cdreproducao = 
	(select first 1 re.cdreproducao from reproducao re where re.cdtiporeproducao = 7 and re.cdanimal = par.cdanimal and re.data < par.data order by re.data desc)
    left join tipoparto tp on tp.cdtipoparto = par.cdtipoparto
    left join reproducao cob on cob.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdtiporeproducao in (1,2,3) and re.cdanimal = par.cdanimal and re.data < par.data order by re.data desc)
    left join setor se on se.cdsetor = an.cdsetor
where
    an.tipoanimal = 'A'
    and an.animalrebanho = 1
    and an.dtbaixa is null
    and an.cdcategoria = '7'
order by
    an.numordenado
    


